ToParentBlockJoinQuery (Lucene 3.6.2 API)
Keywords: org.apache.lucene.search.join.ToParentBlockJoinQuery class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.search.join
Class ToParentBlockJoinQuery

    java.lang.Object
      org.apache.lucene.search.Query
          org.apache.lucene.search.join.ToParentBlockJoinQuery

All Implemented Interfaces:
  Serializable, Cloneable

    public class ToParentBlockJoinQuery

extends org.apache.lucene.search.Query

This query requires that you index children and parent docs as a single block, using the `IndexWriter.addDocuments(java.util.Collection)` or `IndexWriter.updateDocuments(org.apache.lucene.index.Term, java.util.Collection)` API. In each block, the child documents must appear first, ending with the parent document. At search time you provide a Filter identifying the parents, however this Filter must provide an `FixedBitSet` per sub-reader.

WARNING: to create the parents filter, always use `RawTermFilter` (so that the filter includes deleted docs), wrapped with `CachingWrapperFilter` (so that the returned bit set per reader is a `FixedBitSet`), specifying DeletesMode.IGNORE (so that on reopen, the filter still includes deleted docs). Failure to do this can result in completely wrong documents being returned! For example:

       Filter parents = new CachingWrapperFilter(
                              new RawTermFilter(new Term("parent", "yes")),
                              CachingWrapperFilter.DeletesMode.IGNORE);

Once the block index is built, use this query to wrap any sub-query matching only child docs and join matches in that child document space up to the parent document space. You can then use this Query as a clause with other queries in the parent document space.

See `ToChildBlockJoinQuery` if you need to join in the reverse order.

The child documents must be orthogonal to the parent documents: the wrapped child query must never return a parent document.

If you'd like to retrieve `TopGroups` for the resulting query, use the `ToParentBlockJoinCollector`. Note that this is not necessary, ie, if you simply want to collect the parent documents and don't need to see which child documents matched under that parent, then you can use any collector.

NOTE: If the overall query contains parent-only matches, for example you OR a parent-only query with a joined child-only query, then the resulting collected documents will be correct, however the `TopGroups` you get from `ToParentBlockJoinCollector` will not contain every child for parents that had matched.

See `org.apache.lucene.search.join` for an overview.

See Also:
  Serialized Form
WARNING: This API is experimental and might change in incompatible ways in the next release.

Nested Class Summary
`static class` | `ToParentBlockJoinQuery.ScoreMode` How to aggregate multiple child hit scores into a single parent score.

Constructor Summary
`ToParentBlockJoinQuery(org.apache.lucene.search.Query childQuery, org.apache.lucene.search.Filter parentsFilter, ToParentBlockJoinQuery.ScoreMode scoreMode)` Create a ToParentBlockJoinQuery.

Method Summary
`Object` | `clone()`
`org.apache.lucene.search.Weight` | `createWeight(org.apache.lucene.search.Searcher searcher)`
`boolean` | `equals(Object _other)`
`void` | `extractTerms(Set<org.apache.lucene.index.Term> terms)`
`int` | `hashCode()`
`org.apache.lucene.search.Query` | `rewrite(org.apache.lucene.index.IndexReader reader)`
`String` | `toString(String field)`

Methods inherited from class org.apache.lucene.search.Query
`combine, getBoost, getSimilarity, mergeBooleanQueries, setBoost, toString, weight`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### ToParentBlockJoinQuery

    public ToParentBlockJoinQuery(org.apache.lucene.search.Query childQuery,
                                  org.apache.lucene.search.Filter parentsFilter,
                                  ToParentBlockJoinQuery.ScoreMode scoreMode)

  Create a ToParentBlockJoinQuery.

  Parameters:
    `childQuery` - Query matching child documents.
    `parentsFilter` - Filter (must produce FixedBitSet per-seegment) identifying the parent documents.
    `scoreMode` - How to aggregate multiple child scores into a single parent score.

Method Detail

### createWeight

    public org.apache.lucene.search.Weight createWeight(org.apache.lucene.search.Searcher searcher)
                                                 throws IOException

  Overrides:
    `createWeight` in class `org.apache.lucene.search.Query`
  Throws:
    `IOException`

### extractTerms

    public void extractTerms(Set<org.apache.lucene.index.Term> terms)

  Overrides:
    `extractTerms` in class `org.apache.lucene.search.Query`

### rewrite

    public org.apache.lucene.search.Query rewrite(org.apache.lucene.index.IndexReader reader)
                                           throws IOException

  Overrides:
    `rewrite` in class `org.apache.lucene.search.Query`
  Throws:
    `IOException`

### toString

    public String toString(String field)

  Specified by:
    `toString` in class `org.apache.lucene.search.Query`

### equals

    public boolean equals(Object _other)

  Overrides:
    `equals` in class `org.apache.lucene.search.Query`

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `org.apache.lucene.search.Query`

### clone

    public Object clone()

  Overrides:
    `clone` in class `org.apache.lucene.search.Query`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD